/**
 */
package emfer.reachability.impl;

import emfer.reachability.*;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class ReachabilityFactoryImpl extends EFactoryImpl implements ReachabilityFactory
{
   /**
    * Creates the default factory implementation.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public static ReachabilityFactory init()
   {
      try
      {
         ReachabilityFactory theReachabilityFactory = (ReachabilityFactory)EPackage.Registry.INSTANCE.getEFactory(ReachabilityPackage.eNS_URI);
         if (theReachabilityFactory != null)
         {
            return theReachabilityFactory;
         }
      }
      catch (Exception exception)
      {
         EcorePlugin.INSTANCE.log(exception);
      }
      return new ReachabilityFactoryImpl();
   }

   /**
    * Creates an instance of the factory.
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public ReachabilityFactoryImpl()
   {
      super();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public EObject create(EClass eClass)
   {
      switch (eClass.getClassifierID())
      {
         case ReachabilityPackage.REACHABILITY_GRAPH: return createReachabilityGraph();
         case ReachabilityPackage.GAME_STATE: return createGameState();
         case ReachabilityPackage.REACHABLE_STATE: return createReachableState();
         case ReachabilityPackage.OPERATION_NAME: return createOperationName();
         case ReachabilityPackage.TRAFO_APPLICATION: return createTrafoApplication();
         default:
            throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
      }
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public Object createFromString(EDataType eDataType, String initialValue)
   {
      switch (eDataType.getClassifierID())
      {
         case ReachabilityPackage.TURN:
            return createTurnFromString(eDataType, initialValue);
         default:
            throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
      }
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   @Override
   public String convertToString(EDataType eDataType, Object instanceValue)
   {
      switch (eDataType.getClassifierID())
      {
         case ReachabilityPackage.TURN:
            return convertTurnToString(eDataType, instanceValue);
         default:
            throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
      }
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public ReachabilityGraph createReachabilityGraph()
   {
      ReachabilityGraphImpl reachabilityGraph = new ReachabilityGraphImpl();
      return reachabilityGraph;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public GameState createGameState()
   {
      GameStateImpl gameState = new GameStateImpl();
      return gameState;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public ReachableState createReachableState()
   {
      ReachableStateImpl reachableState = new ReachableStateImpl();
      return reachableState;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public OperationName createOperationName()
   {
      OperationNameImpl operationName = new OperationNameImpl();
      return operationName;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public TrafoApplication createTrafoApplication()
   {
      TrafoApplicationImpl trafoApplication = new TrafoApplicationImpl();
      return trafoApplication;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public Turn createTurnFromString(EDataType eDataType, String initialValue)
   {
      Turn result = Turn.get(initialValue);
      if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
      return result;
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public String convertTurnToString(EDataType eDataType, Object instanceValue)
   {
      return instanceValue == null ? null : instanceValue.toString();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @generated
    */
   public ReachabilityPackage getReachabilityPackage()
   {
      return (ReachabilityPackage)getEPackage();
   }

   /**
    * <!-- begin-user-doc -->
    * <!-- end-user-doc -->
    * @deprecated
    * @generated
    */
   @Deprecated
   public static ReachabilityPackage getPackage()
   {
      return ReachabilityPackage.eINSTANCE;
   }

} //ReachabilityFactoryImpl
